<?php

function project_meta_box() {
  add_meta_box(
    'page_meta_box1',//ID of meta box
    __('Project information for right sidebar', 'tcd-w'),//label
    'show_project_meta_box',//callback function
    'project',// post type
    'normal',// context
    'high'// priority
  );
}
add_action('add_meta_boxes', 'project_meta_box');

function show_project_meta_box() {
  global $post;
  $options =  get_desing_plus_option();

  $project_catch = array( 'name' => __('Catchphrase', 'tcd-w'), 'desc' => '', 'id' => 'project_catch', 'type' => 'textarea', 'std' => '' );
  $project_catch_meta = esc_html(get_post_meta($post->ID, 'project_catch', true));

  $project_info = array( 'name' => __('Project overview', 'tcd-w'), 'desc' => '', 'id' => 'project_info', 'type' => 'textarea', 'std' => '' );
  $project_info_meta = get_post_meta($post->ID, 'project_info', true);

  // ---------------------------------------------------------------------

  echo '<input type="hidden" name="custom_fields_meta_box_nonce" value="', wp_create_nonce(basename(__FILE__)), '" />';

  //入力欄 ***************************************************************************************************************************************************************************************

  echo '<dl class="ml_custom_fields">';

  echo '<dt class="label"><label for="' , $project_catch['id'] , '">' , $project_catch['name'] , '</label></dt>';
  echo '<dd class="content">';
  echo '<textarea name="', $project_catch['id'], '" id="', $project_catch['id'], '" cols="60" rows="2" style="width:100%;">', $project_catch_meta ? $project_catch_meta : $project_catch['std'], '</textarea>';
  echo '</dd>';

  echo '<dt class="label"><label>' , $project_info['name'] ,'</label></dt>';
  echo '<dd class="content"><p class="desc">' ,  $project_info['desc'] , '</p>';
  wp_editor( $project_info_meta, 'project_info', array(
      'textarea_name' => 'project_info',
      'textarea_rows' => 20
  ));
  echo '</dd>';

  echo '</dl>';

}

function save_project_meta_box( $post_id ) {

  // verify nonce
  if (!isset($_POST['custom_fields_meta_box_nonce']) || !wp_verify_nonce($_POST['custom_fields_meta_box_nonce'], basename(__FILE__))) {
    return $post_id;
  }

  // check autosave
  if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) {
    return $post_id;
  }

  // check permissions
  if ('page' == $_POST['post_type']) {
    if (!current_user_can('edit_page', $post_id)) {
      return $post_id;
    }
  } elseif (!current_user_can('edit_post', $post_id)) {
      return $post_id;
  }

  // save or delete
  $cf_keys = array('project_info','project_catch');
  foreach ($cf_keys as $cf_key) {
    $old = get_post_meta($post_id, $cf_key, true);

    if (isset($_POST[$cf_key])) {
      $new = $_POST[$cf_key];
    } else {
      $new = '';
    }

    if ($new && $new != $old) {
      update_post_meta($post_id, $cf_key, $new);
    } elseif ('' == $new && $old) {
      delete_post_meta($post_id, $cf_key, $old);
    }
  }

}
add_action('save_post', 'save_project_meta_box');

